'//+--------------------------------------------------------------------------+
'//|                                                                          |
'//|                               DWM spinner                                |
'//|                                                                          |
'//|                      Composited spinner annimation                       |
'//|                                                                          |
'//+--------------------------------------------------------------------------+
'//|                                                                          |
'//|                         Author Patrice TERRIER                           |
'//|                            copyright(c) 2014                             |
'//|                           www.zapsolution.com                            |
'//|                        pterrier@zapsolution.com                          |
'//|                                                                          |
'//+--------------------------------------------------------------------------+
'//|                  Project started on : 01-05-2014 (MM-DD-YYYY)            |
'//|                        Last revised : 01-13-2014 (MM-DD-YYYY)            |
'//+--------------------------------------------------------------------------+

#COMPILE EXE "DWMspinnerPB.exe"
'#INCLUDE "WIN32API.INC" '<<-- Using this enlarges the code with an extra 10 Kb

%NULL                 = 0
%BI_RGB               = 0
%DIB_RGB_COLORS       = 0
%SRCCOPY              = &H00CC0020
%LB_ERR               = -1
%TRUE                 = 1
%VK_ESCAPE            = &H1B
%HTCAPTION            = 2
%MAX_PATH             = 260
%CS_HREDRAW           = &H0002
%CS_VREDRAW           = &H0001
%CS_OWNDC             = &H0020
%IDC_ARROW            = 32512
%INVALID_HANDLE_VALUE = -1

TYPE RGBQUAD BYTE
    rgbBlue     AS BYTE
    rgbGreen    AS BYTE
    rgbRed      AS BYTE
    rgbReserved AS BYTE
END TYPE

TYPE BITMAPINFOHEADER
    biSize          AS DWORD
    biWidth         AS LONG
    biHeight        AS LONG
    biPlanes        AS WORD
    biBitCount      AS WORD
    biCompression   AS DWORD
    biSizeImage     AS DWORD
    biXPelsPerMeter AS LONG
    biYPelsPerMeter AS LONG
    biClrUsed       AS DWORD
    biClrImportant  AS DWORD
END TYPE

TYPE BITMAPINFO
    bmiHeader AS BITMAPINFOHEADER
    bmiColors(0) AS RGBQUAD
END TYPE

TYPE RECT
    left   AS LONG
    top    AS LONG
    right  AS LONG
    bottom AS LONG
END TYPE

TYPE POINTAPI
    x AS LONG
    y AS LONG
END TYPE

TYPE SIZEL
    cx AS LONG
    cy AS LONG
END TYPE

TYPE WNDCLASSEXW BYTE
    cbSize        AS DWORD
    style         AS DWORD
    lpfnWndProc   AS DWORD
    cbClsExtra    AS LONG
    cbWndExtra    AS LONG
    hInstance     AS DWORD
    hIcon         AS DWORD
    hCursor       AS DWORD
    hbrBackground AS DWORD
    lpszMenuName  AS WSTRINGZ PTR
    lpszClassName AS WSTRINGZ PTR
    hIconSm       AS DWORD
END TYPE

TYPE SECURITY_ATTRIBUTES
    nLength AS DWORD
    lpSecurityDescriptor AS LONG
    bInheritHandle AS LONG
END TYPE

TYPE tagMSG DWORD
    hwnd    AS DWORD
    message AS DWORD
    wParam  AS DWORD
    lParam  AS LONG
    time    AS DWORD
    pt      AS POINTAPI
END TYPE

TYPE FILETIME
    dwLowDateTime AS DWORD
    dwHighDateTime AS DWORD
END TYPE

TYPE WIN32_FIND_DATA
    dwFileAttributes AS DWORD
    ftCreationTime AS FILETIME
    ftLastAccessTime AS FILETIME
    ftLastWriteTime AS FILETIME
    nFileSizeHigh AS DWORD
    nFileSizeLow AS DWORD
    dwReserved0 AS DWORD
    dwReserved1 AS DWORD
    cFileName AS WSTRINGZ * %MAX_PATH
    cAlternateFileName AS WSTRINGZ * 14
END TYPE

DECLARE FUNCTION LoadLibrary LIB "KERNEL32.DLL" ALIAS "LoadLibraryW" (lpLibFileName AS WSTRINGZ) AS LONG
DECLARE FUNCTION GetProcAddress LIB "KERNEL32.DLL" ALIAS "GetProcAddress" (BYVAL hModule AS DWORD, lpProcName AS STRINGZ) AS LONG
DECLARE FUNCTION CreateDIBSection LIB "GDI32.DLL" ALIAS "CreateDIBSection" (BYVAL hdc AS DWORD, pbmi AS BITMAPINFO, BYVAL dwUsage AS DWORD, BYVAL ppvBits AS DWORD, BYVAL hSection AS DWORD, BYVAL dwOffset AS DWORD) AS DWORD
DECLARE FUNCTION CreateRectRgn LIB "GDI32.DLL" ALIAS "CreateRectRgn" (BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS DWORD
DECLARE FUNCTION GetWindowRect LIB "USER32.DLL" ALIAS "GetWindowRect" (BYVAL hWnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION SetRect LIB "USER32.DLL" ALIAS "SetRect" (lpRect AS RECT, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION GetDC LIB "USER32.DLL" ALIAS "GetDC" (BYVAL hWnd AS DWORD) AS DWORD
DECLARE FUNCTION CreateCompatibleDC LIB "GDI32.DLL" ALIAS "CreateCompatibleDC" (BYVAL hdc AS DWORD) AS DWORD
DECLARE FUNCTION SelectObject LIB "GDI32.DLL" ALIAS "SelectObject" (BYVAL hdc AS DWORD, BYVAL hObject AS DWORD) AS DWORD
DECLARE FUNCTION ReleaseDC LIB "USER32.DLL" ALIAS "ReleaseDC" (BYVAL hWnd AS DWORD, BYVAL hDC AS DWORD) AS LONG
DECLARE FUNCTION CreateSolidBrush LIB "GDI32.DLL" ALIAS "CreateSolidBrush" (BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION FillRect LIB "USER32.DLL" ALIAS "FillRect" (BYVAL hDC AS DWORD, lpRect AS RECT, BYVAL hBrush AS DWORD) AS LONG
DECLARE FUNCTION DeleteObject LIB "GDI32.DLL" ALIAS "DeleteObject" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION BitBlt LIB "GDI32.DLL" ALIAS "BitBlt" (BYVAL hDestDC AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hSrcDC AS DWORD, BYVAL xSrc AS LONG, BYVAL ySrc AS LONG, BYVAL dwRop AS DWORD) AS LONG
DECLARE SUB      apiSleep LIB "KERNEL32.DLL" ALIAS "Sleep" (BYVAL dwMilliseconds AS DWORD)
DECLARE FUNCTION CreateThread LIB "KERNEL32.DLL" ALIAS "CreateThread" (lpThreadAttributes AS SECURITY_ATTRIBUTES, BYVAL dwStackSize AS DWORD, BYVAL StartAddress AS DWORD, BYVAL lpParam AS DWORD, BYVAL dwCreat AS DWORD, lpThreadId AS DWORD) AS DWORD
DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION GetDesktopWindow LIB "USER32.DLL" ALIAS "GetDesktopWindow" () AS LONG
DECLARE FUNCTION GetClassInfoExW LIB "USER32.DLL" ALIAS "GetClassInfoExW" (BYVAL hInstance AS DWORD, BYREF lpszClass AS WSTRINGZ, BYREF lpwcx AS WNDCLASSEXW) AS LONG
DECLARE FUNCTION RegisterClassExW LIB "USER32.DLL" ALIAS "RegisterClassExW" (BYREF lpwcx AS WNDCLASSEXW) AS WORD
DECLARE FUNCTION CreateWindowExW LIB "USER32.DLL" ALIAS "CreateWindowExW" (BYVAL dwExStyle AS DWORD, BYREF lpClassName AS WSTRINGZ, BYREF lpWindowName AS WSTRINGZ, BYVAL dwStyle AS DWORD, BYVAL X AS LONG, BYVAL Y AS LONG, _
                                                                           BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, OPTIONAL BYVAL hwndParent AS DWORD, OPTIONAL BYVAL hMenu AS DWORD, OPTIONAL BYVAL hInstance AS DWORD, _
                                                                           OPTIONAL BYREF lpParam AS ANY) AS DWORD
DECLARE SUB      RtlMoveMemory LIB "KERNEL32.DLL" ALIAS "RtlMoveMemory" (BYVAL Dest AS DWORD, BYVAL Srce AS DWORD, BYVAL Length AS DWORD)
DECLARE FUNCTION DestroyWindow LIB "USER32.DLL" ALIAS "DestroyWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION UpdateWindow LIB "USER32.DLL" ALIAS "UpdateWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetMessage LIB "USER32.DLL" ALIAS "GetMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL uMsgFilterMin AS DWORD, BYVAL uMsgFilterMax AS DWORD) AS LONG
DECLARE FUNCTION TranslateMessage LIB "USER32.DLL" ALIAS "TranslateMessage" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION DispatchMessage LIB "USER32.DLL" ALIAS "DispatchMessageA" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION IsWindow LIB "USER32.DLL" ALIAS "IsWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION MoveWindow LIB "USER32.DLL" ALIAS "MoveWindow" (BYVAL hWnd AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL bRepaint AS LONG) AS LONG
DECLARE FUNCTION DeleteDC LIB "GDI32.DLL" ALIAS "DeleteDC" (BYVAL hdc AS DWORD) AS LONG
DECLARE SUB PostQuitMessage LIB "USER32.DLL" ALIAS "PostQuitMessage" (BYVAL nExitCode AS LONG)
DECLARE FUNCTION DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" (BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorW" (BYVAL hInstance AS DWORD, lpCursorName AS WSTRINGZ) AS DWORD
DECLARE FUNCTION FindFirstFile LIB "KERNEL32.DLL" ALIAS "FindFirstFileW" (lpFileName AS WSTRINGZ, lpFindFileData AS WIN32_FIND_DATA) AS DWORD
DECLARE FUNCTION FindClose LIB "KERNEL32.DLL" ALIAS "FindClose" (BYVAL hFindFile AS DWORD) AS LONG

%TIMER_DELAY = 30

%S_OK = 0
%WM_DWMCOMPOSITIONCHANGED     = &H031E
%DWM_BB_ENABLE                = &H00000001
%DWM_BB_BLURREGION            = &H00000002
%DWM_BB_TRANSITIONONMAXIMIZED = &H00000004
%DWM_EC_ENABLECOMPOSITION     = 1
%DWM_EC_DISABLECOMPOSITION    = 0

type DWM_BLURBEHIND
    dwFlags  as DWORD
    fEnable  as long
    hRgnBlur as DWORD
    fTransitionOnMaximized as long
end type

type GdiplusStartupInput
    GdiplusVersion           as DWORD
    DebugEventCallback       as DWORD
    SuppressBackgroundThread as long
    SuppressExternalCodecs   as long
end type

type PROP
    hwnd        as DWORD
    img         as DWORD
    framecount  as long
    frametouse  as long
    'orientation as long
    hdc         as DWORD
    hbitmap     as DWORD
    hgdiplus    as DWORD
end type

%HORZ = 1
%VERT = 2

global gP as PROP

DECLARE FUNCTION DwmIsCompositionEnabled LIB "dwmapi.dll" ALIAS "DwmIsCompositionEnabled" (byref bEnabled as long) as long
DECLARE FUNCTION DwmEnableBlurBehindWindow LIB "dwmapi.dll" ALIAS "DwmEnableBlurBehindWindow" (byval DWORD, pBlurBehind as DWM_BLURBEHIND) as long

DECLARE FUNCTION GdiplusStartup LIB "gdiplus.dll" ALIAS "GdiplusStartup" (byref hGDIplus as DWORD, inputbuf as GdiplusStartupInput, byval outputbuf as DWORD) as long
DECLARE FUNCTION GdiplusShutdown LIB "gdiplus.dll" ALIAS "GdiplusShutdown" (byval hGDIplus as DWORD) as long
DECLARE FUNCTION GdipLoadImageFromFile LIB "gdiplus.dll" ALIAS "GdipLoadImageFromFile" (szImgName as WSTRINGZ, byref lpImg as DWORD) as long
DECLARE FUNCTION GdipDeleteGraphics LIB "gdiplus.dll" ALIAS "GdipDeleteGraphics" (byval lpImg as DWORD) as long
DECLARE FUNCTION GdipDisposeImage LIB "gdiplus.dll" ALIAS "GdipDisposeImage" (byval lpImg as DWORD) as long
DECLARE FUNCTION GdipGetImageWidth LIB "gdiplus.dll" ALIAS "GdipGetImageWidth" (byval lpImg as DWORD, byref imgW as long) as long
DECLARE FUNCTION GdipGetImageHeight LIB "gdiplus.dll" ALIAS "GdipGetImageHeight" (byval lpImg as DWORD, byref imgH as long) as long
DECLARE FUNCTION GdipCreateFromHDC LIB "gdiplus.dll" ALIAS "GdipCreateFromHDC" (byval hDC as DWORD, byref graphics as DWORD) as long
DECLARE FUNCTION GdipDrawImageRectRectI LIB "gdiplus.dll" ALIAS "GdipDrawImageRectRectI" ( _
                                        byval graphics as DWORD, byval lpImg as DWORD, byval dstX as long, byval dstY as long, byval dstW as long, byval dstH as long, byval srcX as long, byval srcY as long, byval srcW as long, byval srcH as long, _
                                        byval srcUnit as long, byval imageattr as DWORD, byval lpCallback as DWORD, byval callbackdata as DWORD) as long

function Exist(szFileSpec as WSTRINGZ) as long
    local fd as WIN32_FIND_DATA
    local bRet as long
    if len(szFileSpec) then
        local hFind as DWORD
        hFind = FindFirstFile(szFileSpec, fd)
        if hFind <> %INVALID_HANDLE_VALUE then
            FindClose(hFind)
            bRet = %TRUE
        end if
    end if
    function = bRet
end function

function GdipStart () as DWORD
    '// Load the GDI+ Dll
    if (gP.hgdiplus = 0) then
        local GpInput as GdiplusStartupInput
        local hGDIplus as DWORD
        GpInput.GdiplusVersion = 1
        if (GdiplusStartup(hGDIplus, GpInput, %NULL) = 0) then
            gP.hgdiplus = hGDIplus
        end if
    end if
    function = gP.hgdiplus
end function

sub GdipEnd ()
    if (gP.hgdiplus) then GdiplusShutdown(gP.hgdiplus)
end sub

sub zSetCrystalBehindMode(byval hWnd as DWORD, byval dwmEnabled as long)
    local bb as DWM_BLURBEHIND
    local hLib as DWORD, nRet, hRgnBlur as long
    static hProc as DWORD
    if dwmEnabled then
       '// Create and populate the BlurBehind structure.
       '// Set Blur Behind and Blur Region.
       bb.fEnable = dwmEnabled
       bb.dwFlags = %DWM_BB_ENABLE OR %DWM_BB_BLURREGION
       bb.fTransitionOnMaximized = 0
       '// Fool VISTA with a fake region
       if dwmEnabled then hRgnBlur = CreateRectRgn(-1, -1, 0, 0)
       bb.hRgnBlur = hRgnBlur
       '// Set Blur Behind mode.
       nRet = DwmEnableBlurBehindWindow(hWnd, bb)
    end if
end sub

function CreateDIBSection32(byval hDC as DWORD, byval nWidth as long, byval nHeight as long) as DWORD
    local bi as BITMAPINFO
    bi.bmiHeader.biSize = sizeof(bi.bmiHeader)
    bi.bmiHeader.biWidth = nWidth
    bi.bmiHeader.biHeight = -nHeight
    bi.bmiHeader.biPlanes = 1
    bi.bmiHeader.biBitCount = 32
    bi.bmiHeader.biCompression = %BI_RGB
    function = CreateDIBSection(hDC, bi, %DIB_RGB_COLORS, %NULL, %NULL, %NULL)
end function

sub Animate (byval Delay as DWORD)
    local nWait as DWORD
    local nFrame as long
    local graphics as DWORD
    local r as RECT
    local w, h as long
    GetWindowRect(gP.hwnd, r)
    w = r.right - r.left: h = r.bottom - r.top
    SetRect(r, 0, 0, w, h)
    local hBrush as DWORD
    
    if (gP.img = 0) then exit sub

    DoLoop:
        if (gP.hbitmap = 0) then
            local DesktopDC as DWORD: DesktopDC = GetDC(0)
            gP.hdc = CreateCompatibleDC(DesktopDC)
            gP.hbitmap = CreateDIBSection32(gP.hdc, w, h)
            SelectObject(gP.hdc, gP.hbitmap)
            ReleaseDC(0, DesktopDC)
        end if
        if (gP.hbitmap) then

            '// Create a null brush, to clear the background of our permanent bitmap.
            hBrush = CreateSolidBrush(%NULL)
            SelectObject(gP.hdc, hBrush)
            FillRect(gP.hdc, r, hBrush)
            DeleteObject(hBrush)

            if (GdipCreateFromHDC(gP.hdc, graphics) = 0) then
                gP.frametouse += 1: if (gP.frametouse > gP.framecount) then gP.frametouse = 1
                if (gP.img) then
                    GdipDrawImageRectRectI(graphics, gP.img, 0, 0, w, h, w * gP.frametouse - w, 0, w, h, 2, 0, %NULL, %NULL)
                end if
                GdipDeleteGraphics(graphics)
            end if

            '// Warning we use a permanent DC (%CS_OWNDC)
            BitBlt(GetDC(gP.hwnd), 0, 0, w, h, gP.hdc, 0, 0, %SRCCOPY)

            apiSLEEP(Delay)

        end if

    goto DoLoop

end sub

function StartAnimation (byval Delay as DWORD) as long
    local nRet as long: nRet = %LB_ERR
    local hThread, dwThreadId as DWORD
    hThread = CreateThread(byval %NULL, _         '// default security attributes
                           0, _                   '// use default stack size  
                           CODEPTR(Animate), _    '// thread function name
                           Delay, _               '// argument to thread function 
                           0, _                   '// use default creation flags 
                           dwThreadId)            '// returns the thread identifier
    if (hThread) then nRet = 0: apiSLEEP(100)
    CloseHandle(hThread)
    function = nRet
end function

sub SpinnerInit (byval hParent as DWORD, byval hWnd as DWORD, szFileName as WSTRINGZ, byval nSpeedDelay as long)

    if (IsWindow(hParent) = 0) then hParent = GetDesktopWindow()

    gP.framecount = 0
    if (gP.img) then GdipDisposeImage(gP.img): gP.img = 0

    if (GdipLoadImageFromFile(szFileName, gP.img) = 0) then
        local w, h as long
        local r as RECT: GetWindowRect(hParent, r)
        GdipGetImageWidth(gP.img, w)
        GdipGetImageHeight(gP.img, h)
        gP.framecount = w \ h
        MoveWindow(hWnd, r.left + ((r.right - r.left - h) \ 2), r.top + ((r.bottom - r.top - h) \ 2), h, h, 0)

        local dwmEnabled as long
        if (DwmIsCompositionEnabled(dwmEnabled) = 0) then
            if dwmEnabled then zSetCrystalBehindMode(hWnd, dwmEnabled)
        end if
        if (nSpeedDelay = 0) then
            if (gP.framecount < 4) then
                nSpeedDelay = 75
            elseif (gP.framecount < 8) then
                nSpeedDelay = 50
            elseif (gP.framecount < 12) then
                nSpeedDelay = 37
            else
                nSpeedDelay = %TIMER_DELAY
            end if
        end if

        gP.hwnd = hWnd: StartAnimation(nSpeedDelay)

    end if
end sub

function SpinnerProc (byval hWnd as DWORD, byval uMsg as DWORD, byval wParam as long, byval lParam as long) as long
    select case long (uMsg)
    case %WM_KEYDOWN:
         if (wParam = %VK_ESCAPE) then DestroyWindow(hWnd)

    case %WM_NCHITTEST:
         function = %HTCAPTION: exit function

    case %WM_DESTROY:
         if (gP.hbitmap) then DeleteObject(gP.hbitmap)
         if (gP.hdc) then DeleteDC(gP.hdc)
         PostQuitMessage(0)
         if (gP.img) then GdipDisposeImage(gP.img): gP.img = 0
         function = 0: exit function
    end select
    function = DefWindowProc(hWnd, uMsg, wParam, lParam)
end function

function WinMain (byval hInstance as DWORD, byval hPrevInstance AS DWORD, _
                  byval lpCmdLine as WSTRINGZ PTR, byval iCmdShow as long) as long
    local hWnd, hParent as DWORD
    local nRet, nSpeedDelay as long
    local msg as tagMSG
    local wcx as WNDCLASSEXW
    local szClassName as WSTRINGZ * 16: szClassName = "ZSPIN_DWM32"
    local szFileName as WSTRINGZ * %MAX_PATH

    wcx.cbSize = sizeof(wcx):
    local IsInitialized as long: IsInitialized = GetClassInfoExW(hInstance, szClassName, wcx)
    if (IsInitialized     = 0) then
        wcx.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_OWNDC
        wcx.lpfnWndProc   = CODEPTR(SpinnerProc)
        wcx.cbClsExtra    = 0
        wcx.cbWndExtra    = 0
        wcx.hInstance     = hInstance
        wcx.hIcon         = %NULL
        wcx.hCursor       = LoadCursor(%NULL, byval %IDC_ARROW)
        wcx.hbrBackground = %NULL
        wcx.lpszMenuName  = %NULL
        wcx.lpszClassName = VARPTR(szClassName)
        wcx.hIconSm       = wcx.hIcon
        if (RegisterClassExW(wcx)) then IsInitialized = -1
    end if

    if (IsInitialized) then
        hWnd = CreateWindowExW(%WS_EX_TOOLWINDOW OR %WS_EX_TOPMOST, szClassName, szClassName, %WS_POPUP OR %WS_VISIBLE, _
                               0, 0, 0, 0, %NULL, %NULL, hInstance, byval %NULL)
        if (hWnd) then
            'szFileName = lpCmdLine
            'MEMORY COPY lpCmdLine, VARPTR(szFileName), sizeof(szFileName)
            RtlMoveMemory(VARPTR(szFileName), lpCmdLine, sizeof(szFileName))
            if (Exist(szFileName)) then
                GdipStart(): if (gP.hgdiplus) then SpinnerInit (hParent, hWnd, szFileName, nSpeedDelay)
            end if
            if (gP.hgdiplus = 0) then DestroyWindow(hWnd)

            UpdateWindow(hWnd)

            while (GetMessage(msg, %NULL, 0, 0))
                TranslateMessage(msg)
                DispatchMessage(msg)
            wend

            GdipEnd()
            nRet = msg.wParam
        end if
    end if
    function = nRet
end function
 